<template>
  <div>
    <input
      v-show="false"
      type="file"
      accept="json/*"
      ref="inputJson"
      @change="getJSONData"
    >

    <button
      class="btn--main"
      :class="{ 'btn--error': error }"
      :title="message"
      @click="selectFile"
    >
      Load json file
      
      <img v-if="error" src="../../assets/images/alert-box.svg" alt="Note">
    </button>
  </div>
</template>

<script>
  import Vue from 'vue'
  import getDataFromJsonFile from './getDataFromJsonFile'
  import sampleData from './sample-data'

  import { SET_NODE_TREE } from '../../store/node/mutations'

  export default {
    name: 'DataLoader',
    data() {
      return {
        error: null
      }
    },

    computed: {
      message() {
        if(this.error) return `${this.error} .json file expected with similar data format: ${Vue.filter('formatToJson')(sampleData)}`
        return `.json file expected with similar data format: ${Vue.filter('formatToJson')(sampleData)}`
      }
    },

    methods: {
      selectFile() {
        this.$refs.inputJson.value = null
        this.error = ''
        this.$refs.inputJson.click()
      },

      async getJSONData(e) {
        try {
          const data = await getDataFromJsonFile(e.target.files)
          this.$store.commit(SET_NODE_TREE, data)
        } catch (error) {
          this.error = error
        }
      }
    }
  }
</script>

<style lang="scss" scoped>
  .btn--main {
    display: flex;
    align-items: center;
    justify-content: center;

    img {
      width: 19px;
      height: 19px;
      margin-left: 1rem;
    }
  }
</style>
